# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/GNSSRfErrorDetection.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class GNSSRfErrorDetection(genpy.Message):
  _md5sum = "4a93766f3edd7ed65c5dd957cfa071bb"
  _type = "microstrain_inertial_msgs/GNSSRfErrorDetection"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint8 rf_band  # Must be one of the RF_BAND_* values
uint8 jamming_state  # Must be one of JAMMING_STATE_* values
uint8 spoofing_state  # Must be one of SPOOFING_STATE_* values
uint16 valid_flags

# Enum values for rf_band field
uint8 RF_BAND_UNKNOWN = 0
uint8 RF_BAND_L1 = 1
uint8 RF_BAND_L2 = 2
uint8 RF_BAND_L5 = 5

# Enum values for jamming_state field
uint8 JAMMING_STATE_UNKNOWN = 0
uint8 JAMMING_STATE_NONE = 1
uint8 JAMMING_STATE_PARTIAL = 2
uint8 JAMMING_STATE_SIGNIFICANT = 3

# Enum values for spoofing_state field
uint8 SPOOFING_STATE_UNKNOWN = 0
uint8 SPOOFING_STATE_NONE = 1
uint8 SPOOFING_STATE_PARTIAL = 2
uint8 SPOOFING_STATE_SIGNIFICANT = 3"""
  # Pseudo-constants
  RF_BAND_UNKNOWN = 0
  RF_BAND_L1 = 1
  RF_BAND_L2 = 2
  RF_BAND_L5 = 5
  JAMMING_STATE_UNKNOWN = 0
  JAMMING_STATE_NONE = 1
  JAMMING_STATE_PARTIAL = 2
  JAMMING_STATE_SIGNIFICANT = 3
  SPOOFING_STATE_UNKNOWN = 0
  SPOOFING_STATE_NONE = 1
  SPOOFING_STATE_PARTIAL = 2
  SPOOFING_STATE_SIGNIFICANT = 3

  __slots__ = ['rf_band','jamming_state','spoofing_state','valid_flags']
  _slot_types = ['uint8','uint8','uint8','uint16']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       rf_band,jamming_state,spoofing_state,valid_flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GNSSRfErrorDetection, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.rf_band is None:
        self.rf_band = 0
      if self.jamming_state is None:
        self.jamming_state = 0
      if self.spoofing_state is None:
        self.spoofing_state = 0
      if self.valid_flags is None:
        self.valid_flags = 0
    else:
      self.rf_band = 0
      self.jamming_state = 0
      self.spoofing_state = 0
      self.valid_flags = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3BH().pack(_x.rf_band, _x.jamming_state, _x.spoofing_state, _x.valid_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 5
      (_x.rf_band, _x.jamming_state, _x.spoofing_state, _x.valid_flags,) = _get_struct_3BH().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3BH().pack(_x.rf_band, _x.jamming_state, _x.spoofing_state, _x.valid_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 5
      (_x.rf_band, _x.jamming_state, _x.spoofing_state, _x.valid_flags,) = _get_struct_3BH().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3BH = None
def _get_struct_3BH():
    global _struct_3BH
    if _struct_3BH is None:
        _struct_3BH = struct.Struct("<3BH")
    return _struct_3BH
