# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/GNSSSbasInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class GNSSSbasInfo(genpy.Message):
  _md5sum = "d7cb652c633d59430f774c51fd7733f5"
  _type = "microstrain_inertial_msgs/GNSSSbasInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """float32 gps_tow
uint16  gps_week_number
uint8   sbas_system  # Must be equal to one of the SBAS_SYSTEM_* values in this message
uint8   sbas_id
uint8   count

# Parsed out version of the SBAS status bitfield
bool status_range_available
bool status_corrections_available
bool status_integrity_available
bool status_test_mode

# Valid flags can be parsed per the manual to determine which fields are valid
uint16 valid_flags

# Possible values for the sbas_system field
uint8 SBAS_SYSTEM_UNKNOWN = 0
uint8 SBAS_SYSTEM_WAAS = 1
uint8 SBAS_SYSTEM_EGNOS = 2
uint8 SBAS_SYSTEM_MSAS = 3
uint8 SBAS_SYSTEM_GAGAN = 4"""
  # Pseudo-constants
  SBAS_SYSTEM_UNKNOWN = 0
  SBAS_SYSTEM_WAAS = 1
  SBAS_SYSTEM_EGNOS = 2
  SBAS_SYSTEM_MSAS = 3
  SBAS_SYSTEM_GAGAN = 4

  __slots__ = ['gps_tow','gps_week_number','sbas_system','sbas_id','count','status_range_available','status_corrections_available','status_integrity_available','status_test_mode','valid_flags']
  _slot_types = ['float32','uint16','uint8','uint8','uint8','bool','bool','bool','bool','uint16']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       gps_tow,gps_week_number,sbas_system,sbas_id,count,status_range_available,status_corrections_available,status_integrity_available,status_test_mode,valid_flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GNSSSbasInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.gps_tow is None:
        self.gps_tow = 0.
      if self.gps_week_number is None:
        self.gps_week_number = 0
      if self.sbas_system is None:
        self.sbas_system = 0
      if self.sbas_id is None:
        self.sbas_id = 0
      if self.count is None:
        self.count = 0
      if self.status_range_available is None:
        self.status_range_available = False
      if self.status_corrections_available is None:
        self.status_corrections_available = False
      if self.status_integrity_available is None:
        self.status_integrity_available = False
      if self.status_test_mode is None:
        self.status_test_mode = False
      if self.valid_flags is None:
        self.valid_flags = 0
    else:
      self.gps_tow = 0.
      self.gps_week_number = 0
      self.sbas_system = 0
      self.sbas_id = 0
      self.count = 0
      self.status_range_available = False
      self.status_corrections_available = False
      self.status_integrity_available = False
      self.status_test_mode = False
      self.valid_flags = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_fH7BH().pack(_x.gps_tow, _x.gps_week_number, _x.sbas_system, _x.sbas_id, _x.count, _x.status_range_available, _x.status_corrections_available, _x.status_integrity_available, _x.status_test_mode, _x.valid_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 15
      (_x.gps_tow, _x.gps_week_number, _x.sbas_system, _x.sbas_id, _x.count, _x.status_range_available, _x.status_corrections_available, _x.status_integrity_available, _x.status_test_mode, _x.valid_flags,) = _get_struct_fH7BH().unpack(str[start:end])
      self.status_range_available = bool(self.status_range_available)
      self.status_corrections_available = bool(self.status_corrections_available)
      self.status_integrity_available = bool(self.status_integrity_available)
      self.status_test_mode = bool(self.status_test_mode)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_fH7BH().pack(_x.gps_tow, _x.gps_week_number, _x.sbas_system, _x.sbas_id, _x.count, _x.status_range_available, _x.status_corrections_available, _x.status_integrity_available, _x.status_test_mode, _x.valid_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 15
      (_x.gps_tow, _x.gps_week_number, _x.sbas_system, _x.sbas_id, _x.count, _x.status_range_available, _x.status_corrections_available, _x.status_integrity_available, _x.status_test_mode, _x.valid_flags,) = _get_struct_fH7BH().unpack(str[start:end])
      self.status_range_available = bool(self.status_range_available)
      self.status_corrections_available = bool(self.status_corrections_available)
      self.status_integrity_available = bool(self.status_integrity_available)
      self.status_test_mode = bool(self.status_test_mode)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_fH7BH = None
def _get_struct_fH7BH():
    global _struct_fH7BH
    if _struct_fH7BH is None:
        _struct_fH7BH = struct.Struct("<fH7BH")
    return _struct_fH7BH
